<template>
  <div class="create-quiz">
    <!-- Header -->
    <!-- <main-header></main-header> -->
    <!-- End Header -->

    <div class="container-md content-section position-relative pb-5">
        <h1 class="overlay-text position-absolute">Create a Quiz</h1>
        <img src="@/assets/img/quiz-bg.png" class="bg position-absolute" />

        <quiz-survey-header></quiz-survey-header>

        <!-- <expired-at @update-expire-at="updateExpireAt"></expired-at> -->

        <quiz-survey-cate @update-cate="updateCate"></quiz-survey-cate>

        <quiz-survey-thumb @update-thumb="updateThumb"></quiz-survey-thumb>

        <quiz-survey-type :type-game="typeGame" @change-type-answer="changeTypeAnswer"></quiz-survey-type>

        <quiz-survey-content @update-content="updateContent" :value-content="quizContent"></quiz-survey-content>

        <quiz-survey-answer
          :type-answer="typeAnswer"
          :answer-value="answerValue"
          @update-answer-value="updateAnswerValue"
        ></quiz-survey-answer>

        <quiz-survey-correct
          :type-answer="typeAnswer"
          :correct-answer="correctAnswer"
          @update-correct-answer="updateCorrectAnswer"
        ></quiz-survey-correct>

        <div class="row">
          <div class="col d-flex justify-content-end">
            <button class="btn btn-danger rounded-pill px-4 py-2 me-4" @click="submitQuiz">Submit</button>
          </div>
        </div>
    </div>

    <!-- Footer -->
    <!-- <main-footer></main-footer> -->
    <!-- End Footer -->
  </div>
</template>

<script>
// import MainHeader from "../components/MainHeader.vue";
// import MainFooter from "../components/MainFooter.vue";
import QuizSurveyHeader from "../components/quiz-survey/QuizSurveyHeader.vue";
import QuizSurveyType from "../components/quiz-survey/QuizSurveyType.vue";
import QuizSurveyContent from "../components/quiz-survey/QuizSurveyContent.vue";
import QuizSurveyAnswer from "../components/quiz-survey/QuizSurveyAnswer.vue";
import QuizSurveyCorrect from "../components/quiz-survey/QuizSurveyCorrect.vue";
import QuizSurveyThumb from "../components/quiz-survey/QuizSurveyThumb.vue";
import QuizSurveyCate from "../components/quiz-survey/QuizSurveyCate.vue";
// import ExpiredAt from "../components/quiz-survey/ExpiredAt.vue";
import { apiCustomerPost } from "../services/baseApi.js";
import sweetAlert from "../helper/sweetAlert.js";

export default {
  components: {
    // MainHeader,
    // MainFooter,
    QuizSurveyHeader,
    QuizSurveyType,
    QuizSurveyContent,
    QuizSurveyAnswer,
    QuizSurveyCorrect,
    QuizSurveyThumb,
    QuizSurveyCate
  },
  data() {
    return {
      typeGame: "quiz",
      expiredAt: "",
      cateId: "1",
      thumbUrl: "",
      quizContent: "",
      typeAnswer: "quiz-1",
      correctAnswer: "x",
      answerValue: [
        { key: "1", content: "" },
        { key: "2", content: "" },
        { key: "3", content: "" },
        { key: "4", content: "" }
      ],
    };
  },
  methods: {
    changeTypeAnswer(data) {
      this.typeAnswer = data;
      if (data === 'quiz-1') {
        this.correctAnswer = "x";
      } else {
        this.correctAnswer = "1";
      }
    },
    updateCate(data) {
      this.cateId = data;
    },
    updateThumb(data) {
      this.thumbUrl = data;
    },
    updateContent(data) {
      this.quizContent = data;
    },
    updateCorrectAnswer(data) {
      this.correctAnswer = data;
    },
    updateAnswerValue(data) {
      this.answerValue = this.answerValue.map((item) => {
        if (item.key !== data.key) return item;

        item.content = data.content;
        return item;
      });
    },
    updateExpireAt(data) {
      this.expiredAt = data;
    },
    async submitQuiz() {
      try {
        let user = localStorage.getItem('user');
        user = JSON.parse(user);
        let userId = user.id;
        let userName = user.name;

        if (!userId || !this.quizContent) {
          sweetAlert.toastAlert(this, 'error', 'Please enter all required information');
          return;
        }

        // Quiz data
        let dataQuiz = {
          name: userName,
          description: this.quizContent,
          thumnail: this.thumbUrl,
          created_by: userId,
          type: "",
          suggestanswer: "",
          answer: "",
          // expiredAt: this.expiredAt
        };
        dataQuiz.type = this.typeAnswer === "quiz-2" ? 0 : 2;
        dataQuiz.suggestanswer = this.correctAnswer;
        dataQuiz.answer = "[]";

        if (this.typeAnswer === "quiz-2") {
          let result = "[";
          let arrJson = this.answerValue.map(item => JSON.stringify(item));

          result += arrJson.join(",") + "]";
          dataQuiz.answer = result;
        }

        let params = { quizz: dataQuiz };
        // Call service
        let createQuiz = await apiCustomerPost("quizz", params);

        if (createQuiz && createQuiz.data && createQuiz.data.status) {
          this.$router.push("/submit-success").catch(() => {});
        }
      } catch (error) {
        console.log(error);
        sweetAlert.toastAlert(this, 'error', 'Submit has failed');
      }
    }
  }
};
</script>

<style scoped>
.content-section {
  max-width: 100vw;
  overflow: hidden;
  padding-top: 100px;
  padding-bottom: 30px;
}
.content-section .bg {
  width: 120vw;
  height: 100%;
  top: 0;
  left: 0;
  transform: translateX(-20vw);
  object-fit: cover;
  z-index: -1;
}
.content-section .overlay-text {
  font-size: 150px;
  color: #dadadbaa;
  top: 0;
  left: 0;
  white-space: nowrap;
  z-index: -1;
  width: 100vw;
  overflow: hidden;
}
</style>
